/*******************************************************************
 Copyright (C) 2004 Thomas Kunz, CRC Canada, BCAST for IPv4.
 DISTRIBUTED WITH NO WARRANTY, EXPRESS OR IMPLIED.
 See the GNU Library General Public License (file COPYING in the
 MANET_multicast directory) for conditions of use and redistribution.
*********************************************************************/

/*
 * Functions to manage a cache of packets. The cache is of fixed size
 * (determined at creation time) and managed in FIFO order.
 */

#ifndef _cache_
#define _cache_

#include <packet.h>
#include <ip.h>
#include <rtp.h>

/*
  Packet Cache
*/

class PacketCache {
 public:
        PacketCache(int size);
        void 	packet_insert(Packet *p);
        Packet* packet_lookup(nsaddr_t src, u_int32_t seqno);
 protected:
        Packet **cache;
	int cache_size;
	int current;
};
	
#endif
